/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cd.hologram.erecettesvg.sql;

/**
 *
 * @author gauthier.muata
 */
public class SQLQueryRecouvrement {

    public static String SELECT_TAUX_BY_DEVISE = "SELECT TOP 1 * FROM T_TAUX WITH (READPAST) "
            + " WHERE DEVISE = ?1 AND DEVISE_DEST = 'CDF' ORDER BY ID DESC";

    public static String F_CHECK_EXIST_ARTICLE_ROLE = "SELECT DBO.F_CHECK_EXIST_ARTICLE_ROLE";

    public static String SELECT_MASTER_LIST_MED_V1 = "SELECT PD.* FROM T_PERIODE_DECLARATION PD WITH (READPAST) WHERE PD.ETAT = 1 \n"
            + "AND PD.ASSUJETISSEMENT IN (SELECT A.ID FROM T_ASSUJETI A WITH (READPAST) \n"
            + "WHERE A.ARTICLE_BUDGETAIRE = ?1) AND PD.NOTE_CALCUL IS NULL AND (PD.DATE_LIMITE < GETDATE() OR PD.FIN < GETDATE()) %s";

    public static String SELECT_MASTER_LIST_MED_V11 = "SELECT PD.* FROM T_PERIODE_DECLARATION PD WITH (READPAST) WHERE PD.ETAT = 1 \n"
            + "AND PD.ASSUJETISSEMENT IN (SELECT A.ID FROM T_ASSUJETI A WITH (READPAST) \n"
            + "WHERE A.ARTICLE_BUDGETAIRE = ?1 OR A.ARTICLE_BUDGETAIRE IN ('00000000000002352021','00000000000002362021')) AND CAST(PD.ID AS INT) NOT IN (SELECT ISNULL(CAST(FK_PERIODE AS INT),0) FROM T_RETRAIT_DECLARATION WITH (READPAST)) AND (PD.DATE_LIMITE < GETDATE()) %s";

    public static String SELECT_MASTER_LIST_MED_V2 = "SELECT PD.* FROM T_PERIODE_DECLARATION PD WITH (READPAST) WHERE PD.ETAT = 1 \n"
            + "AND PD.ASSUJETISSEMENT IN (SELECT A.ID FROM T_ASSUJETI A WITH (READPAST) \n"
            + "WHERE A.PERSONNE = ?1) AND PD.NOTE_CALCUL IS NULL AND (PD.DATE_LIMITE < GETDATE() OR PD.FIN < GETDATE())";
    
    public static String SELECT_MASTER_LIST_MED_V22 = "SELECT PD.* FROM T_PERIODE_DECLARATION PD WITH (READPAST) WHERE PD.ETAT = 1 \n"
            + "AND PD.ASSUJETISSEMENT IN (SELECT A.ID FROM T_ASSUJETI A WITH (READPAST) \n"
            + "WHERE A.PERSONNE = ?1) AND CAST(PD.ID AS INT) NOT IN (SELECT ISNULL(CAST(FK_PERIODE AS INT),0) FROM T_RETRAIT_DECLARATION WITH (READPAST) WHERE ETAT = 1) AND (PD.DATE_LIMITE < GETDATE())";

    public static String SELECT_MED_BY_PERIODE_DECLARATION = "SELECT M.* FROM T_MED M WITH (READPAST)\n"
            + "WHERE M.PERIODE_DECLARATION = ?1 AND M.ETAT > 0";

    public static String SELECT_MED_BY_PERIODE_DECLARATION_2 = "SELECT M.* FROM T_MED M WITH (READPAST) WHERE M.PERIODE_DECLARATION = ?1 AND M.ETAT > 0 AND M.TYPE_MED = ?2";

    public static String SELECT_MED_BY_NOTE_PERCEPTION = "SELECT M.* FROM T_MED M WITH (READPAST)\n"
            + "WHERE M.NOTE_PERCEPTION = ?1 AND M.ETAT > 0";

    public static String SELECT_MED_BY_ID = "SELECT M.* FROM T_MED M WITH (READPAST)\n"
            + "WHERE M.ID = ?1 AND M.ETAT > 0";

    public static String F_NEW_MED = ":EXEC F_NEW_MED ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11";

    public static String F_NEW_MED_SERVICE = ":EXEC F_NEW_MED_SERVICE ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11,?12";

    public static String F_NEW_NOTE_PERCEPTION_PENALITE = ":EXEC F_NEW_NOTE_PERCEPTION_PENALITE ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11";

    public static String F_UPDATE_PRINT_MED = ":UPDATE T_MED SET DATE_IMPRESSION = GETDATE(), ETAT_IMPRESSION= 1 "
            + " WHERE ID = ?1";

    public static String SELECT_LOGIN_WEB_BY_ASSUJETTI = "SELECT * FROM T_LOGIN_WEB WITH (READPAST) WHERE FK_PERSONNE = ?1 AND ETAT = 1";

    public static String SELECT_LIST_NOTE_PERCEPTION_NOT_PAID_V1 = "SELECT NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST)\n"
            + "WHERE NP.ETAT > 0 AND NP.NUMERO NOT IN (SELECT J.DOCUMENT_APURE FROM T_JOURNAL J WITH (READPAST))\n"
            + "AND NP.NOTE_CALCUL IN (SELECT NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.PERSONNE = ?1)\n"
            + "AND NP.DATE_ECHEANCE_PAIEMENT < GETDATE() AND ETAT IN (2,3)";

    public static String SELECT_LIST_NOTE_PERCEPTION_NOT_PAID_ROLE = "SELECT NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST) WHERE NP.ETAT > 0 AND NP.NUMERO NOT \n"
            + "  IN (SELECT J.DOCUMENT_APURE FROM T_JOURNAL J WITH (READPAST)) AND NP.NUMERO \n"
            + "  IN (SELECT M.NOTE_PERCEPTION FROM T_MED M  WITH (READPAST) WHERE M.PERSONNE = ?1 AND M.DATE_ECHEANCE < GETDATE())";

    public static String SELECT_LIST_NOTE_PERCEPTION_NOT_PAID_V2 = "SELECT NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST) "
            + " WHERE NP.NOTE_CALCUL IN (SELECT NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) "
            + " WHERE NC.SITE = ?1 AND NC.SERVICE = ?2) AND NP.NUMERO NOT IN (SELECT J.DOCUMENT_APURE "
            + " FROM T_JOURNAL J WITH (READPAST)) AND NP.DATE_ECHEANCE_PAIEMENT < GETDATE() %s";

    public static String SELECT_LIST_NOTE_PERCEPTION_NOT_PAID_V3 = "SELECT NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST) "
            + " WHERE NP.NOTE_CALCUL IN (SELECT NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) "
            + " %s) AND NP.NUMERO NOT IN (SELECT J.DOCUMENT_APURE "
            + " FROM T_JOURNAL J WITH (READPAST)) AND NP.DATE_ECHEANCE_PAIEMENT < GETDATE() AND ETAT IN (2,3) %s";

    public static String SELECT_LIST_NOTE_PERCEPTION_NOT_PAID_ROLE2 = "SELECT NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST)  WHERE NP.NOTE_CALCUL \n"
            + "  IN (SELECT NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST)  %s) AND NP.NUMERO NOT IN (SELECT J.DOCUMENT_APURE \n"
            + "  FROM T_JOURNAL J WITH (READPAST)) AND NP.NUMERO \n"
            + "  IN (SELECT M.NOTE_PERCEPTION FROM T_MED M  WITH (READPAST) WHERE  M.DATE_ECHEANCE < GETDATE()) %s";

    public static String SELECT_NOTE_PERCEPTION_DEPENDANCY = "SELECT NP.* FROM T_NOTE_PERCEPTION NP "
            + " WITH (READPAST) WHERE NP.NP_MERE = ?1";

    public static class Role {

        public static String F_NEW_ROLE = "F_NEW_ROLE";
        public static String F_NEW_DETAILS_ROLE = ":EXEC F_NEW_DETAILS_ROLE ?1, ?2, '%s', '%s' :";
        public static String F_NEW_EXTRAIT_DE_ROLE = "F_NEW_EXTRAIT_DE_ROLE";

        public static String SELECT_LIST_PROJET_ROLE = "SELECT R.* FROM T_ROLE R WITH (READPAST) "
                + " WHERE R.ETAT IN (1,2,3) %s %s %s %s";

        public static String SELECT_LIST_EXTRAIT_ROLE_A_ORDONNANCER = "SELECT EXR.* FROM T_EXTRAIT_DE_ROLE EXR WITH (READPAST)"
                + " WHERE EXR.ORDONNANCE = 0 AND EXR.ETAT = 2 AND EXR.FK_ROLE  IN (SELECT ID FROM T_ROLE R WITH (READPAST)"
                + " WHERE ETAT = 1 %s ) %s %s %s";

        public static String SELECT_LIST_EXTRAIT_ROLE_APURERE = "SELECT EXR.* FROM T_EXTRAIT_DE_ROLE EXR WITH (READPAST)"
                + " WHERE EXR.ETAT = 1 AND EXR.ID IN (SELECT J.DOCUMENT_APURE FROM T_JOURNAL J WITH (READPAST) WHERE J.ETAT = 2)"
                + " AND EXR.FK_ROLE IN (SELECT ID FROM T_ROLE WITH (READPAST)  WHERE ETAT = 1) %s %s %s %s ";

        public static String SELECT_LIST_EXTRAIT_ROLE_ORDONNANCER = "SELECT EXR.* FROM T_EXTRAIT_DE_ROLE EXR WITH (READPAST) "
                + " WHERE EXR.ORDONNANCE = 1 AND EXR.ETAT IN (1,3) AND EXR.FK_ROLE IN (SELECT ID FROM T_ROLE R WITH (READPAST) "
                + " WHERE ETAT = 1 %s ) %s %s %s";

//        public static String SELECT_EXTRAIT_ROLE_BY_SERVICE = " AND  EXR.ID IN (SELECT DISTINCT DR.FK_EXTRAIT_ROLE "
//                + " FROM T_DETAILS_ROLE  DR WITH (READPAST) WHERE DR.DOCUMENT_REF IN (SELECT NP.NUMERO "
//                + " FROM T_NOTE_PERCEPTION NP WITH (READPAST) WHERE NP.NOTE_CALCUL IN (SELECT NC.NUMERO "
//                + " FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE = '%s')))";
//
//        public static String SELECT_EXTRAIT_ROLE_BY_SERVICE2 = " AND  EXR.ID IN (SELECT DISTINCT DR.FK_EXTRAIT_ROLE "
//                + " FROM T_DETAILS_ROLE  DR WITH (READPAST) WHERE DR.DOCUMENT_REF IN (SELECT NP.NUMERO "
//                + " FROM T_NOTE_PERCEPTION NP WITH (READPAST) WHERE NP.NOTE_CALCUL IN (SELECT NC.NUMERO "
//                + " FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE IN (%s))))";
//
//        public static String SELECT_EXTRAIT_ROLE_BY_SERVICE_ALL = " AND  EXR.ID IN (SELECT DISTINCT DR.FK_EXTRAIT_ROLE "
//                + " FROM T_DETAILS_ROLE  DR WITH (READPAST) WHERE DR.DOCUMENT_REF IN (SELECT NP.NUMERO "
//                + " FROM T_NOTE_PERCEPTION NP WITH (READPAST) WHERE NP.NOTE_CALCUL IN (SELECT NC.NUMERO "
//                + " FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE "
//                + " IN (SELECT CODE FROM T_SERVICE WITH (READPAST) WHERE SERVICE = '%s'))))";
//        public static String SELECT_EXTRAIT_ROLE_BY_SITE = " AND EXR.ID IN (SELECT DISTINCT DR.FK_EXTRAIT_ROLE "
//                + " FROM T_DETAILS_ROLE DR WITH (READPAST) WHERE DR.DOCUMENT_REF IN (SELECT NP.NUMERO "
//                + " FROM T_NOTE_PERCEPTION NP WITH (READPAST) WHERE NP.SITE = '%s' ))";
//
//        public static String SELECT_EXTRAIT_ROLE_BY_SITE2 = " AND EXR.ID IN (SELECT DISTINCT DR.FK_EXTRAIT_ROLE "
//                + " FROM T_DETAILS_ROLE DR WITH (READPAST) WHERE DR.DOCUMENT_REF IN (SELECT NP.NUMERO "
//                + " FROM T_NOTE_PERCEPTION NP WITH (READPAST) WHERE NP.SITE IN (%s) ))";
        public static String SELECT_EXTRAIT_ROLE_BY_ARTICLE_ROLE = " AND (EXR.ARTICLE_ROLE = ?1 OR "
                + " EXR.FK_ROLE IN (SELECT ID FROM T_ROLE R WITH (READPAST) WHERE R.ARTICLE_ROLE = ?1))";

        public static String SELECT_ROLE_PART_QUERY_2_BY_ARTICLE_ROLE = " AND EXR.ARTICLE_ROLE = ?1 ";

        public static String SELECT_EXTRAIT_ROLE_BY_ASSUJETTI = " AND DBO.F_GET_PERSONNE_NAME(EXR.FK_PERSONNE) LIKE ?1";
        public static String SELECT_EXTRAIT_ROLE_BY_CODE = " AND EXR.FK_PERSONNE = '%s' ";

        public static String SELECT_ROLE_PART_QUERY_1_BY_ARTICLE_ROLE = " AND R.ARTICLE_ROLE = '%s'";

        public static String SELECT_DETAIL_ROLE_BY_SITE_SERVICE = " AND R.ID IN (SELECT FK_ROLE R FROM T_DETAILS_ROLE DR WHERE DR.DOCUMENT_REF "
                + " IN (SELECT NP.NUMERO FROM T_NOTE_PERCEPTION NP WITH (READPAST) WHERE NP.SITE IN (%s) AND NP.NOTE_CALCUL IN (SELECT NC.NUMERO  FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.SERVICE IN (%s))))";

        public static String SELECT_DETAIL_ROLE_BY_SITE_SERVICE_V2 = " AND R.ID IN (SELECT FK_ROLE R FROM T_DETAILS_ROLE DR WHERE DR.DOCUMENT_REF "
                + " IN (SELECT NP.NUMERO  FROM T_NOTE_PERCEPTION NP WITH (READPAST) WHERE NP.NOTE_CALCUL IN (SELECT NC.NUMERO  FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.SITE IN (%s) AND NC.SERVICE IN (%s) )) "
                + " OR DR.DOCUMENT_REF IN (SELECT BP.CODE FROM T_BON_A_PAYER BP WITH (READPAST) "
                + " WHERE BP.FK_NOTE_CALCUL IN (SELECT NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.SITE IN (%s) AND NC.SERVICE IN (%s) ))) ";

        public static String SELECT_DETAIL_ROLE_BY_SITE_SERVICE_ALL = "AND R.ID IN (SELECT FK_ROLE R FROM T_DETAILS_ROLE DR WHERE DR.DOCUMENT_REF "
                + " IN (SELECT NP.NUMERO  FROM T_NOTE_PERCEPTION NP WITH (READPAST) WHERE NP.NOTE_CALCUL IN (SELECT NC.NUMERO  FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.SITE IN (SELECT S.CODE FROM T_SITE S WITH (READPAST) WHERE S.FK_ENTITE IN (SELECT E.ID "
                + " FROM T_ENTITE E WITH (READPAST) WHERE E.FK_PROVINCE IN (%s))) )) "
                + " OR DR.DOCUMENT_REF IN (SELECT BP.CODE FROM T_BON_A_PAYER BP WITH (READPAST) "
                + " WHERE BP.FK_NOTE_CALCUL IN (SELECT NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.SITE IN (SELECT S.CODE FROM T_SITE S WITH (READPAST) "
                + " WHERE S.FK_ENTITE IN (SELECT E.ID FROM T_ENTITE E WITH (READPAST) WHERE E.FK_PROVINCE IN (%s))))))";

        //public static String SELECT_DETAIL_ROLE_BY_SITE_SERVICE_ALL = "";
        public static String SELECT_ROLE_PART_QUERY_3_BY_SERVICE_ALL = " AND R.ID IN (SELECT DISTINCT DR.FK_ROLE "
                + " FROM T_DETAILS_ROLE DR WITH (READPAST) WHERE DR.DOCUMENT_REF IN (SELECT NP.NUMERO "
                + " FROM T_NOTE_PERCEPTION NP WITH (READPAST) WHERE NP.ETAT > 0 AND NP.NOTE_CALCUL IN (SELECT NC.NUMERO "
                + " FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE IN (SELECT CODE FROM T_SERVICE WITH (READPAST)"
                + " WHERE SERVICE = '%s'))))";

        public static String SELECT_EXTRAIT_ROLE_PART_QUERY_4_BY_DATE_CREATE = " AND DBO.FDATE(EXR.DATE_CREAT) BETWEEN '%s' AND '%s'";

        public static String SELECT_ROLE_PART_QUERY_4_BY_DATE_CREATE = " AND DBO.FDATE(R.DATE_CREAT) BETWEEN '%s' AND '%s'";

        public static String VALIDATION_ROLE_BY_RECEVEUR = ":UPDATE T_ROLE SET ETAT = 1, OBSERVATION_RECEVEUR = ?1 WHERE ID = ?2";

        public static String VALIDATION_ROLE_BY_DIRECTION = ":UPDATE T_ROLE SET ETAT = 1, OBSERVATION_DIRECTION = ?1 WHERE ID = ?2";

        public static String F_UPDATE_DETAILS_ROLE = ":EXEC F_UPDATE_DETAILS_ROLE ?1,?2";

        public static String SELECT_ROLE_BY_ID = "SELECT * FROM T_ROLE WITH (READPAST) WHERE ID = ?1";

        public static String SELECT_DETAILs_NC_BY_NC = "SELECT  TOP 1 * FROM T_DETAILS_NC WITH (READPAST) "
                + " WHERE NOTE_CALCUL = ?1";
    }

    public static class ExtraitRole {

        public static String F_UPDATE_EXTRAIT = ":EXEC F_UPDATE_EXTRAIT ?1";

        public static String SELECT_EXTRAIT_ROLE_BY_ID = "SELECT * FROM T_EXTRAIT_DE_ROLE WITH (READPAST) WHERE ID = ?1";

        public static String SELECT_EXTRAIT_ROLE_BY_ROLE = "SELECT * FROM T_EXTRAIT_DE_ROLE WITH (READPAST) WHERE FK_ROLE = ?1";

        public static String SELECT_EXTRAIT_ROLE_BY_ARTICLE_ROLE = "SELECT * FROM T_EXTRAIT_DE_ROLE WITH (READPAST)"
                + " WHERE FK_ROLE IN (SELECT ID FROM T_ROLE WITH (READPAST) WHERE ARTICLE_ROLE = ?1)";

        public static String SELECT_EXTRAIT_ROLE_BY_ARTICLE_EXTRAIT_ROLE = "SELECT * FROM T_EXTRAIT_DE_ROLE WITH (READPAST)"
                + " WHERE ARTICLE_ROLE = ?1";

        public static String SELECT_LIST_NP_BY_NC_OF_EXTRAIT_ROLE = "SELECT NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST) "
                + " WHERE NP.NOTE_CALCUL IN (SELECT NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.REFERENCE_PROCEDURE = ?1)";

        public static String SELECT_LIST_NP_BY_EXTRAIT_ROLE = "SELECT NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST) "
                + " WHERE NP.NUMERO IN (SELECT DEXR.DOCUMENT_REF FROM T_DETAILS_ROLE DEXR WITH (READPAST) "
                + " WHERE DEXR.FK_EXTRAIT_ROLE = ?1)";

        public static String SELECT_LIST_BP_BY_EXTRAIT_ROLE = "SELECT BP.* FROM T_BON_A_PAYER BP WITH (READPAST)  "
                + " WHERE BP.CODE IN (SELECT DEXR.DOCUMENT_REF FROM T_DETAILS_ROLE DEXR WITH (READPAST) "
                + " WHERE DEXR.FK_EXTRAIT_ROLE = ?1)";

        public static String SELECT_BP_BY_CODE = "SELECT BP.* FROM T_BON_A_PAYER BP WITH (READPAST) WHERE BP.CODE = ?1";

        public static String SELECT_BP_BY_EXTRAIT_ROLE = "SELECT BP.* FROM T_BON_A_PAYER BP WITH (READPAST) WHERE BP.EXTRAIT_ROLE_ID = ?1"
                + " AND BP.CODE NOT IN (SELECT J.DOCUMENT_APURE FROM T_JOURNAL J WITH (READPAST))";

        public static String SELECT_JOURNAL_BY_TITRE_SPECIAL = "SELECT J.* FROM T_JOURNAL J WITH (READPAST) "
                + " WHERE J.DOCUMENT_APURE = ?1 AND ETAT = 2";

        public static String F_NEW_NOTE_CALCUL_V2 = "F_NEW_NOTE_CALCUL_V2";
        public static String F_NEW_NOTE_PERCEPTION_EXTRAIT_ROLE = "F_NEW_NOTE_PERCEPTION_EXTRAIT_ROLE";

        public static String SELECT_LIST_NC_BY_EXTRAIT_ROLE = " SELECT NC.NUMERO FROM T_NOTE_CALCUL NC "
                + " WITH (READPAST) WHERE NC.REFERENCE_PROCEDURE = ?1";

        public static String SELECT_LIST_DETAILS_ROLE_BY_EXTRAIT = "SELECT DR.* FROM T_DETAILS_ROLE DR WITH (READPAST)"
                + "  WHERE DR.FK_EXTRAIT_ROLE = ?1 AND DR.DOCUMENT_REF NOT IN (SELECT J.DOCUMENT_APURE FROM T_JOURNAL J WITH (READPAST))";

        public static String UPDATE_DOCUMENT_REFERENCE_BY_EXTRAIT_ROLE = "EXEC F_UPDATE_DOCUMENT_REFERENCE_BY_EXTRAIT_ROLE '%s'";

        public static String F_GET_EXTRAIT_ROLE_NIVEAU = "SELECT DBO.F_GET_EXTRAIT_ROLE_NIVEAU";

        public static String UPDATE_ECHEANCE_EXTRAIT_ROLE_BY_ARTICLE_EXTRAIT_ROLE = ":UPDATE  T_EXTRAIT_DE_ROLE "
                + " SET DATE_ECHEANCE = ?1 WHERE ARTICLE_ROLE = ?2";
    }

    public static class Contrainte {

        public static String F_NEW_CONTRAINTE = "EXEC F_NEW_CONTRAINTE ?1,?2,?3,?4,?5,?6,?7,?8";

        public static String SELECT_LIST_CONTRAINTE = "SELECT C.* FROM T_CONTRAINTE C WITH (READPAST) "
                + " WHERE C.ETAT IN (1,3) %s %s %s %s %s";

        public static String SELECT_SQL_PART_CONTRAINTE_BY_PERSONNE = " AND DBO.F_GET_PERSONNE_NAME(C.FK_PERSONNE) LIKE ?1 ";

        public static String SELECT_SQL_PART_CONTRAINTE_BY_CODE_PERSONNE = " AND C.FK_PERSONNE = '%s' ";

        public static String SELECT_SQL_PART_CONTRAINTE_BY_ROLE_ARTICLE = " AND C.FK_DERNIER_AVERTISSEMENT IN "
                + " (SELECT DA.ID FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE IN "
                + " (SELECT EXT.ID FROM T_EXTRAIT_DE_ROLE EXT WITH (READPAST) WHERE EXT.ARTICLE_ROLE = ?1))";

        public static String SELECT_SQL_PART_CONTRAINTE_BY_SITE = " AND C.FK_DERNIER_AVERTISSEMENT IN (SELECT DA.ID "
                + " FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE IN "
                + " (SELECT DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.SITE = '%s'))";

        public static String SELECT_SQL_PART_CONTRAINTE_BY_SITE2 = " AND C.FK_DERNIER_AVERTISSEMENT IN (SELECT DA.ID "
                + " FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE IN "
                + " (SELECT DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.SITE IN (%s)))";

        public static String SELECT_SQL_PART_CONTRAINTE_BY_SERVICE = " AND C.FK_DERNIER_AVERTISSEMENT IN (SELECT DA.ID "
                + " FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE IN "
                + " (SELECT DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.SERVICE = '%s'))";

        public static String SELECT_SQL_PART_CONTRAINTE_BY_SERVICE2 = " AND C.FK_DERNIER_AVERTISSEMENT IN (SELECT DA.ID "
                + " FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE IN "
                + " (SELECT DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.SERVICE IN (%s)))";

        public static String SELECT_SQL_PART_CONTRAINTE_BY_SERVICE_ALL = " AND C.FK_DERNIER_AVERTISSEMENT IN (SELECT DA.ID "
                + " FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE IN "
                + " (SELECT DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.SERVICE IN (SELECT CODE FROM T_SERVICE WITH (READPAST) WHERE SERVICE = '%s')))";

        public static String SELECT_SQL_PART_CONTRAINTE_BY_DATE_CREATE = " AND DBO.FDATE(C.DATE_CREAT) BETWEEN '%s' AND '%s'";

        public static String SELECT_CONTRAINTE_BY_ID = " SELECT C.* FROM T_CONTRAINTE C "
                + " WITH (READPAST) WHERE C.ID = ?1";

        public static String SELECT_CONTRAINTE_BY_HUISSIER = " AND C.FK_AGENT_HUISSIER = '%s'";
        public static String SELECT_COMMENEDEMENET_BY_HUISSIER = " AND C.FK_CONTRAINTE in( select CT.ID from T_CONTRAINTE CT WITH (READPAST)  where CT.FK_AGENT_HUISSIER = '%s' ) ";

        public static String SELECT_SQL_PART_CONTRAINTE_BY_HUISSIER = " AND C.FK_AGENT_HUISSIER = ?1";
    }

    public static class Commandement {

        public static String F_NEW_COMMANDEMENT = "EXEC F_NEW_COMMANDEMENT ?1,?2,?3,?4,?5,?6,?7,?8";

        public static String SELECT_LIST_COMMANDEMENT = "SELECT C.* FROM T_COMMANDEMENT C "
                + " WITH (READPAST) WHERE C.ETAT IN (1,2,3,4) %s %s %s %s %s";

        public static String SELECT_COMMANDEMENT_OF_APUREMENT_SPECIAL = "SELECT C.* FROM T_COMMANDEMENT C "
                + " WITH (READPAST) WHERE C.ETAT IN (1,2,3,4) "
                + " AND C.ID IN(SELECT J.DOCUMENT_APURE FROM T_JOURNAL J WITH (READPAST) WHERE J.ETAT = 2)  %s %s %s";

        public static String SELECT_SQL_PART_COMMANDEMENT_BY_PERSONNE = " AND DBO.F_GET_PERSONNE_NAME(C.FK_PERSONNE) LIKE ?1 ";
        public static String SELECT_SQL_PART_COMMANDEMENT_BY_CODE_PERSONNE = " AND C.FK_PERSONNE = '%s' ";

        public static String SELECT_SQL_PART_COMMANDEMENT_BY_ROLE_ARTICLE = " AND C.FK_CONTRAINTE IN "
                + " (SELECT C.ID FROM T_CONTRAINTE C WITH (READPAST) WHERE C.FK_DERNIER_AVERTISSEMENT IN"
                + " (SELECT DA.ID FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE IN"
                + " (SELECT EXT.ID FROM T_EXTRAIT_DE_ROLE EXT WITH (READPAST) WHERE EXT.ARTICLE_ROLE = ?1)))";

        public static String SELECT_SQL_PART_COMMANDEMENT_BY_SITE = " AND C.FK_CONTRAINTE IN (SELECT C.ID "
                + " FROM T_CONTRAINTE C WITH (READPAST) WHERE C.FK_DERNIER_AVERTISSEMENT IN (SELECT DA.ID "
                + " FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE IN "
                + " (SELECT DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST)"
                + " WHERE NC.SITE = '%s')))";

        public static String SELECT_SQL_PART_COMMANDEMENT_BY_SITE2 = " AND C.FK_CONTRAINTE IN (SELECT C.ID "
                + " FROM T_CONTRAINTE C WITH (READPAST) WHERE C.FK_DERNIER_AVERTISSEMENT IN (SELECT DA.ID "
                + " FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE IN "
                + " (SELECT DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST)"
                + " WHERE NC.SITE IN (%s))))";

        public static String SELECT_SQL_PART_COMMANDEMENT_BY_SERVICE = " AND C.FK_CONTRAINTE IN (SELECT C.ID "
                + " FROM T_CONTRAINTE C WITH (READPAST) WHERE C.FK_DERNIER_AVERTISSEMENT IN (SELECT DA.ID "
                + " FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE IN "
                + " (SELECT DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST)"
                + " WHERE NC.SERVICE = '%s')))";

        public static String SELECT_SQL_PART_COMMANDEMENT_BY_SERVICE2 = " AND C.FK_CONTRAINTE IN (SELECT C.ID "
                + " FROM T_CONTRAINTE C WITH (READPAST) WHERE C.FK_DERNIER_AVERTISSEMENT IN (SELECT DA.ID "
                + " FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE IN "
                + " (SELECT DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST)"
                + " WHERE NC.SERVICE IN (%s))))";

        public static String SELECT_SQL_PART_COMMANDEMENT_BY_SERVICE_ALL = " AND C.FK_CONTRAINTE IN (SELECT C.ID "
                + " FROM T_CONTRAINTE C WITH (READPAST) WHERE C.FK_DERNIER_AVERTISSEMENT IN (SELECT DA.ID "
                + " FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE IN "
                + " (SELECT DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST)"
                + " WHERE NC.SERVICE IN (SELECT CODE FROM T_SERVICE WHERE SERVICE = '%s'))))";

        public static String SELECT_SQL_PART_COMMANDEMENT_BY_DATE_CREATE = " AND DBO.FDATE(C.DATE_CREAT) BETWEEN '%s' AND '%s'";

        public static String SELECT_NC_BY_CONTRAINTE_ID = "  SELECT NC.* FROM T_NOTE_CALCUL NC "
                + " INNER JOIN T_EXTRAIT_DE_ROLE EXR ON NC.REFERENCE_PROCEDURE = EXR.ID "
                + " INNER JOIN T_DERNIER_AVERTISSEMENT DA ON EXR.ID = DA.FK_EXTRAIT_ROLE "
                + " INNER JOIN T_CONTRAINTE CT ON DA.ID = CT.FK_DERNIER_AVERTISSEMENT "
                + " WHERE CT.ID = ?1";

        public static String SELECT_COMMANDEMENT_BY_ID = "SELECT * FROM T_COMMANDEMENT WITH (READPAST) WHERE ID = ?1";

        public static String SELECT_NC_BY_COMMANDEMENT_ID = "  SELECT NC.* FROM T_NOTE_CALCUL NC "
                + " INNER JOIN T_EXTRAIT_DE_ROLE EXR ON NC.REFERENCE_PROCEDURE = EXR.ID "
                + " INNER JOIN T_DERNIER_AVERTISSEMENT DA ON EXR.ID = DA.FK_EXTRAIT_ROLE "
                + " INNER JOIN T_CONTRAINTE CT ON DA.ID = CT.FK_DERNIER_AVERTISSEMENT "
                + " INNER JOIN T_COMMANDEMENT CM ON CT.ID = CM.FK_CONTRAINTE "
                + " WHERE CM.ID = ?1";

        public static String SELECT_NOTE_PERCEPTION_BY_TITRE_SPECIAL = "SELECT NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST) "
                + " WHERE NP.EXTRAIT_ROLE_ID = ?1 AND NP.NUMERO  NOT IN (SELECT J.DOCUMENT_APURE FROM T_JOURNAL J WITH (READPAST))";

        public static String SELECT_EXTRAIT_ROLE_BY_ID = "SELECT EXT.* FROM T_EXTRAIT_DE_ROLE EXT WITH (READPAST) "
                + " WHERE EXT.ID = ?1 ";

        public static String SELECT_NOTE_PERCEPTION_BY_TITRE_SPECIAL_FRAIS_POURSUITE = "SELECT NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST) "
                + " WHERE NP.EXTRAIT_ROLE_ID = ?1 AND NP.FK_AB_AMENDE = ?2 AND NP.NUMERO  NOT IN (SELECT J.DOCUMENT_APURE FROM T_JOURNAL J WITH (READPAST))";

        public static String SELECT_LIST_BON_A_PAYER_BY_TITRE_SPECIAL_FRAIS_POURSUITE = "SELECT BP.* FROM T_BON_A_PAYER BP WITH (READPAST) "
                + " WHERE BP.EXTRAIT_ROLE_ID = ?1 AND BP.ACTE_GENERATEUR = ?2 AND BP.CODE  NOT IN (SELECT J.DOCUMENT_APURE FROM T_JOURNAL J WITH (READPAST))";
    }

    public static class DernierAvertissement {

        public static String F_NEW_DERNIER_AVERTISSEMENT = ":EXEC F_NEW_DERNIER_AVERTISSEMENT ?1,?2,?3,?4,?5,?6,?7";

        public static String SELECT_LIST_DERNIER_AVERTISSEMENT = "SELECT DA.* FROM T_DERNIER_AVERTISSEMENT DA "
                + " WITH (READPAST) WHERE DA.ETAT IN (1,3) %s %s %s %s";

        public static String SELECT_SQL_PART_DERNIER_AVERTISSEMENT_BY_PERSONNE = " AND DBO.F_GET_PERSONNE_NAME(DA.FK_PERSONNE) LIKE ?1 ";
        public static String SELECT_SQL_PART_DERNIER_AVERTISSEMENT_BY_CODE = " AND DA.FK_PERSONNE = '%s' ";

        public static String SELECT_SQL_PART_DERNIER_AVERTISSEMENT_BY_ROLE_ARTICLE = " AND DA.FK_EXTRAIT_ROLE IN "
                + " (SELECT EXT.ID FROM T_EXTRAIT_DE_ROLE EXT WITH (READPAST) WHERE EXT.ARTICLE_ROLE = ?1)";

        public static String SELECT_SQL_PART_DERNIER_AVERTISSEMENT_BY_SITE = " AND DA.FK_EXTRAIT_ROLE IN (SELECT "
                + " DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SITE = '%s')";

        public static String SELECT_SQL_PART_DERNIER_AVERTISSEMENT_BY_SITE2 = " AND DA.FK_EXTRAIT_ROLE IN (SELECT "
                + " DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SITE IN (%s))";

        public static String SELECT_SQL_PART_DERNIER_AVERTISSEMENT_BY_SERVICE = " AND DA.FK_EXTRAIT_ROLE IN (SELECT "
                + " DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE = '%s')";

        public static String SELECT_SQL_PART_DERNIER_AVERTISSEMENT_BY_SERVICE2 = " AND DA.FK_EXTRAIT_ROLE IN (SELECT "
                + " DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE IN (%s))";

        public static String SELECT_SQL_PART_DERNIER_AVERTISSEMENT_BY_SERVICE_ALL = " AND DA.FK_EXTRAIT_ROLE IN (SELECT "
                + " DISTINCT NC.REFERENCE_PROCEDURE FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE "
                + " IN (SELECT CODE FROM T_SERVICE WHERE SERVICE = '%s'))";

        public static String SELECT_SQL_PART_DERNIER_AVERTISSEMENT_BY_DATE_CREATE = " AND DBO.FDATE(DA.DATE_CREAT) BETWEEN '%s' AND '%s'";

        public static String SELECT_DERNIER_AVERTISSEMEN_BY_ID = " SELECT DA.ID FROM T_DERNIER_AVERTISSEMENT DA "
                + " WITH (READPAST) WHERE DA.ID = ?1";

        public static String SELECT_DERNIER_AVERTISSEMENT_BY_EXTRAIT_AND_ASSUJETTI = "SELECT DA.* "
                + " FROM T_DERNIER_AVERTISSEMENT DA WITH (READPAST) WHERE DA.FK_EXTRAIT_ROLE = ?1 "
                + " AND DA.FK_PERSONNE = ?2";

        public static String SELECT_DETAIL_ROLE_BY_SITE_SERVICE_DA = "AND (DA.FK_EXTRAIT_ROLE IN (SELECT DR.FK_EXTRAIT_ROLE "
                + " FROM T_DETAILS_ROLE DR WITH (READPAST) WHERE DR.DOCUMENT_REF IN (SELECT BP.CODE "
                + " FROM T_BON_A_PAYER BP WITH (READPAST) WHERE BP.FK_SITE IN (%s) AND BP.FK_NOTE_CALCUL IN (SELECT NC.NUMERO "
                + " FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE IN (%s))))"
                + " OR DA.FK_EXTRAIT_ROLE IN (SELECT DR.FK_EXTRAIT_ROLE FROM T_DETAILS_ROLE DR WITH (READPAST)"
                + " WHERE DR.DOCUMENT_REF IN (SELECT NP.NUMERO FROM T_NOTE_PERCEPTION NP WITH (READPAST)"
                + " WHERE NP.SITE IN (%s) AND NP.NOTE_CALCUL IN (SELECT NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.SERVICE IN (%s)))))";

        public static String SELECT_DETAIL_ROLE_BY_SITE_SERVICE_DA_V2 = "AND (DA.FK_EXTRAIT_ROLE IN (SELECT DR.FK_EXTRAIT_ROLE "
                + " FROM T_DETAILS_ROLE DR WITH (READPAST) WHERE DR.DOCUMENT_REF IN (SELECT BP.CODE "
                + " FROM T_BON_A_PAYER BP WITH (READPAST) WHERE BP.FK_NOTE_CALCUL IN (SELECT NC.NUMERO "
                + " FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SITE IN (%s) AND NC.SERVICE IN (%s))))"
                + " OR DA.FK_EXTRAIT_ROLE IN (SELECT DR.FK_EXTRAIT_ROLE FROM T_DETAILS_ROLE DR WITH (READPAST)"
                + " WHERE DR.DOCUMENT_REF IN (SELECT NP.NUMERO FROM T_NOTE_PERCEPTION NP WITH (READPAST)"
                + " WHERE NP.NOTE_CALCUL IN (SELECT NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.SITE IN (%s) AND NC.SERVICE IN (%s)))))";

        public static String SELECT_DETAIL_ROLE_BY_SITE_SERVICE_DA_ALL = "AND (DA.FK_EXTRAIT_ROLE IN (SELECT DR.FK_EXTRAIT_ROLE "
                + " FROM T_DETAILS_ROLE DR WITH (READPAST) WHERE DR.DOCUMENT_REF IN (SELECT BP.CODE "
                + " FROM T_BON_A_PAYER BP WITH (READPAST) WHERE BP.FK_NOTE_CALCUL IN (SELECT NC.NUMERO "
                + " FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SITE IN (SELECT S.CODE FROM T_SITE S WITH (READPAST) "
                + " WHERE S.FK_ENTITE IN (SELECT E.ID FROM T_ENTITE E WITH (READPAST) "
                + " WHERE E.FK_PROVINCE IN (%s)))))) OR DA.FK_EXTRAIT_ROLE IN (SELECT DR.FK_EXTRAIT_ROLE "
                + " FROM T_DETAILS_ROLE DR WITH (READPAST) WHERE DR.DOCUMENT_REF IN (SELECT NP.NUMERO "
                + " FROM T_NOTE_PERCEPTION NP WITH (READPAST) WHERE NP.NOTE_CALCUL IN (SELECT NC.NUMERO "
                + " FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SITE IN (SELECT S.CODE FROM T_SITE S WITH (READPAST) "
                + " WHERE S.FK_ENTITE IN (SELECT E.ID FROM T_ENTITE E WITH (READPAST) WHERE E.FK_PROVINCE IN (%s)))))))";

    }

}
